$(document).ready(function() {
    let canDraw = true;
    let drawAndMatch = new DrawAndMatch();
    let gameY = $('#thegame').offset().top;
    let gameX = $('#thegame').offset().left;
    drawAndMatch.items.forEach (item => {
        $('#thegame').append('<div class = "item"></div>');
        $('#thegame').append('<div class = "arrow"></div>');
        let addedItem = $('#thegame .item').last();   
        let addedArrow = $('#thegame .arrow').last();                     
        item.setData([addedItem, addedArrow]);
        setItemCss(item, true);
    });
    interact('#thegame').draggable({
        listeners : {
            start : function(event) {
                if (canDraw) {
                    let chainStarted = drawAndMatch.startChain(event.clientX0 - gameX, event.clientY0 - gameY);
                    if (chainStarted) {
                        setItemCss(chainStarted, false);
                    }
                }
            },
            move : function(event) {               
                if (canDraw) {
                    drawAndMatch.handleInputMovement(event.client.x - gameX, event.client.y - gameY).forEach (item => setItemCss(item, true));
                }
            },
            end : function(event) {
                if (canDraw) {
                    canDraw = false;
                    drawAndMatch.removeItems().forEach (item => {
                        $(item.data[1]).css({
                            'display' : 'none'
                        });
                        if (item.toBeRemoved) {
                            $(item.data[0]).addClass('fade');
                        }   
                    });
                    let removed = $('.fade').length;
                    if (removed > 0) {
                        $('.fade').fadeTo(250, 0, function() {
                            $('.fade').removeClass('fade');
                            let itemsToMove = 0;
                            drawAndMatch.arrangeBoard().forEach (item => {    
                                itemsToMove ++;
                                item.data[0].css({
                                    'top' : item.movement.startY,
                                    'left' : item.movement.startX,
                                    'background-position' : item.value * 100
                                });
                                $(item.data[1]).css({
                                    'display' : 'none'
                                });
                                item.data[0].fadeTo(0, 1);
                                $(item.data[0]).animate({
                                    'top' : item.movement.endY,
                                },{
                                    duration : 150 * item.movement.deltaRow,
                                    complete : function() {
                                        itemsToMove --;
                                        if (itemsToMove == 0) {
                                            canDraw = true;
                                        }
                                    }   
                                })
                            });  
                        });
                    }
                    else {
                        canDraw = true;
                    }
                }
            }    
        }
    });
    function setItemCss(item, setArrow) {
        $(item.data[0]).css({
            'top' : item.posY,
            'left' : item.posX,
            'background-position' : item.value * 100
        });
        if (setArrow) {
            $(item.data[1]).css({
                'top' : item.posY - 100,
                'left' : item.posX - 100,
                'display' : item.arrowVisible ? 'block' : 'none',
                'rotate' : arrowLookUpTable[item.arrowDirection].rotate,
                'background-position' : arrowLookUpTable[item.arrowDirection].position
            });
        } 
    }
});

const arrowLookUpTable = [];
arrowLookUpTable[DrawAndMatchDirection.NONE] = {
    position : 0,
    rotate : '90deg'
}
arrowLookUpTable[DrawAndMatchDirection.UP] = {
    position : 0,
    rotate : '270deg'
}
arrowLookUpTable[DrawAndMatchDirection.UP + DrawAndMatchDirection.RIGHT] = {
    position : 300,
    rotate : '270deg'
}
arrowLookUpTable[DrawAndMatchDirection.RIGHT] = {
    position : 0,
    rotate : '0deg'
}
arrowLookUpTable[DrawAndMatchDirection.RIGHT + DrawAndMatchDirection.DOWN] = {
    position : 300,
    rotate : '0deg'
}
arrowLookUpTable[DrawAndMatchDirection.DOWN] = {
    position : 0,
    rotate : '90deg'
}
arrowLookUpTable[DrawAndMatchDirection.DOWN + DrawAndMatchDirection.LEFT] = {
    position : 300,
    rotate : '90deg'
}
arrowLookUpTable[DrawAndMatchDirection.LEFT] = {
    position : 0,
    rotate : '180deg'
}
arrowLookUpTable[DrawAndMatchDirection.LEFT + DrawAndMatchDirection.UP] = {
    position : 300,
    rotate : '180deg'
}